#include "cardappz.h"

int DesfireFormat(CARDAPPZ_CTX_ST * ctx)
{
  int rc;

  rc = DesfireSelectCard(ctx);
  if (rc)
    return rc;

  rc = DesfireFormatCorpid(ctx);
  if (rc)
    return rc;

  rc = DesfireFormatPurse(ctx);
  if (rc)
    return rc;

  rc = DesfireFormatTransport(ctx);
  if (rc)
    return rc;

  return CARDAPPZ_OK;
}

int JaycosFormat(CARDAPPZ_CTX_ST * ctx)
{
  int rc;

  rc = JaycosSelectCard(ctx);
  if (rc)
    return rc;

  rc = JaycosExternalAuthenticate(ctx, 0, JAYCOS_MASTER_KEY);
  if (rc)
    return rc;

  rc = JaycosCreateMF(ctx);
  if (rc)
    return rc;

  rc = JaycosFormatCorpid(ctx);
  if (rc)
    return rc;

  rc = JaycosFormatPurse(ctx);
  if (rc)
    return rc;

  rc = JaycosFormatTransport(ctx);
  if (rc)
    return rc;

  return CARDAPPZ_OK;
}

int Format(CARDAPPZ_CTX_ST * ctx)
{
  if (ctx == NULL)
    return CARDAPPZ_INVALID_CONTEXT;

  switch (ctx->card_type)
  {
    case CARD_DESFIRE:
      return DesfireFormat(ctx);

    case CARD_JAYCOS:
      return JaycosFormat(ctx);
  }

  return CARDAPPZ_NOT_YET_IMPLEMENTED;
}
