// SproxTestDlg.cpp : implementation file
//

#include "StdAfx.h"
#include "SproxTest.h"
#include "SproxTestDlg.h"
#include "hardware/springprox/springprox.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define MAX_SECTORS   40
#define MAX_BYTES     256

/////////////////////////////////////////////////////////////////////////////
// CSproxTestDlg dialog

CSproxTestDlg::CSproxTestDlg(CWnd * pParent /*=NULL*/ )
:CDialog(CSproxTestDlg::IDD, pParent)
{
  //{{AFX_DATA_INIT(CSproxTestDlg)
  m_firmware = _T("");
  m_comm = _T("");
  m_devsnr = _T("");
  m_devtype = _T("");
  m_library = _T("");
  m_tag_atq = _T("");
  m_tag_sak = _T("");
  m_tag_snr = _T("");
  m_result = _T("");
  m_action = _T("");
  m_address = _T("");
  m_value = _T("");
  //}}AFX_DATA_INIT
  // Note that LoadIcon does not require a subsequent DestroyIcon in Win32
  m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSproxTestDlg::DoDataExchange(CDataExchange * pDX)
{
  CDialog::DoDataExchange(pDX);
  //{{AFX_DATA_MAP(CSproxTestDlg)
  DDX_Control(pDX, IDC_VALUE, m_value_ctrl);
  DDX_Control(pDX, IDC_ADDRESS_MODE, m_address_mode);
  DDX_Control(pDX, IDC_READ, m_read);
  DDX_Control(pDX, IDC_ADDRESS_INC, m_address_inc);
  DDX_Control(pDX, IDC_ADDRESS_DEC, m_address_dec);
  DDX_Control(pDX, IDC_LOAD_KEYS, m_load_keys);
  DDX_Control(pDX, IDC_HALT, m_halt);
  DDX_Control(pDX, IDC_SELECT_WAKEUP, m_select_wakeup);
  DDX_Control(pDX, IDC_SELECT_IDLE, m_select_idle);
  DDX_Control(pDX, IDC_SELECT_ANY, m_select_any);
  DDX_Control(pDX, IDC_CLOSE, m_close);
  DDX_Control(pDX, IDC_RESUME, m_resume);
  DDX_Control(pDX, IDC_PAUSE, m_pause);
  DDX_Control(pDX, IDC_OPEN, m_open);
  DDX_Text(pDX, IDC_FIRMWARE, m_firmware);
  DDX_Text(pDX, IDC_COMM, m_comm);
  DDX_Text(pDX, IDC_DEVSNR, m_devsnr);
  DDX_Text(pDX, IDC_DEVTYPE, m_devtype);
  DDX_Text(pDX, IDC_LIBRARY, m_library);
  DDX_Text(pDX, IDC_TAG_ATQ, m_tag_atq);
  DDX_Text(pDX, IDC_TAG_SAK, m_tag_sak);
  DDX_Text(pDX, IDC_TAG_SNR, m_tag_snr);
  DDX_Text(pDX, IDC_RESULT, m_result);
  DDX_Text(pDX, IDC_ACTION, m_action);
  DDX_Text(pDX, IDC_ADDRESS, m_address);
  DDX_Text(pDX, IDC_VALUE, m_value);
  //}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSproxTestDlg, CDialog)
  //{{AFX_MSG_MAP(CSproxTestDlg)
  ON_BN_CLICKED(IDC_OPEN, OnOpen)
ON_BN_CLICKED(IDC_CLOSE, OnClose)
ON_BN_CLICKED(IDC_PAUSE, OnPause)
ON_BN_CLICKED(IDC_RESUME, OnResume)
ON_BN_CLICKED(IDC_SELECT_ANY, OnSelectAny)
ON_BN_CLICKED(IDC_SELECT_IDLE, OnSelectIdle)
ON_BN_CLICKED(IDC_SELECT_WAKEUP, OnSelectWakeup)
ON_BN_CLICKED(IDC_HALT, OnHalt)
ON_BN_CLICKED(IDC_LOAD_KEYS, OnLoadKeys)
ON_BN_CLICKED(IDC_ADDRESS_MODE, OnAddressMode)
ON_BN_CLICKED(IDC_ADDRESS_DEC, OnAddressDec)
ON_BN_CLICKED(IDC_ADDRESS_INC, OnAddressInc) ON_BN_CLICKED(IDC_READ, OnRead)
  //}}AFX_MSG_MAP
END_MESSAGE_MAP()
/////////////////////////////////////////////////////////////////////////////
// CSproxTestDlg message handlers
     BOOL CSproxTestDlg::OnInitDialog()
{
  CDialog::OnInitDialog();

  // Set the icon for this dialog.  The framework does this automatically
  //  when the application's main window is not a dialog
  SetIcon(m_hIcon, TRUE);       // Set big icon
  SetIcon(m_hIcon, false);      // Set small icon

  CenterWindow(GetDesktopWindow()); // center to the hpc screen

  reader_active = false;
  reader_open = false;
  tag_found = false;

  return TRUE;                  // return TRUE  unless you set the focus to a control
}

#if 0
void CSproxTestDlg::OnLoadKey()
{
  m_rc = "Loading keys";
  UpdateData(false);

  if (DefaultKeysToE2() == TRUE)
  {
    m_mess = "Loading keys successful";
    UpdateData(false);
  } else
  {
    m_mess = "Loading keys failed";
    UpdateData(false);
  }
}

/*-----------------------------------------------------------------*/
void CSproxTestDlg::OnWaitCard()
{
  z = 0;
  m_snr = "";
  m_tt = "";
  m_ats = "";
  m_mess = "";

  m_rc = "Waiting for a card";
  UpdateData(false);

  m_control_list.ResetContent();

  if (reader_status == CLOSED)
  {
    OnOpen();
  } else if (reader_status == IDLE)
  {
    OnTilde();
  }

  CWaitCursor patient;

  SetTimer(MYTIMER, 200, NULL);

}

/*-----------------------------------------------------------------*/

void CSproxTestDlg::OnWritebadge()
{
  SWORD rc;
  TCHAR tmp[30];
  BYTE numsect = 0;

  if (MessageBox
      (_T("Are you sure you want to update the sector with current data ?"),
       _T("Write sector"), MB_OKCANCEL | MB_ICONWARNING) != IDOK)
    return;

  if (((numsect = m_control_numsect.GetCurSel()) < 0)
      || numsect > MAX_SECTORS)
  {
    numsect = 0;
  }

  m_rc = "Write sector";
  UpdateData(false);
  {
    CWaitCursor patient;

    rc = SPROX_MifStWriteSector(snr, numsect, sectData, NULL);  // use default keys in EEPROM
    if (rc != MI_OK)
      rc = SPROX_MifStWriteSector(snr, numsect, sectData, demo_key_A);
    if (rc != MI_OK)
      rc = SPROX_MifStWriteSector(snr, numsect, sectData, demo_key_B);
    if (rc != MI_OK)
      rc = SPROX_MifStWriteSector(snr, numsect, sectData, new_key_A);
    if (rc != MI_OK)
      rc = SPROX_MifStWriteSector(snr, numsect, sectData, new_key_B);
  }
  if (rc != MI_OK)
  {
    m_mess = SPROX_GetErrorMessage(rc);
    swprintf(tmp, _T("Writing error on sector %d"), numsect);
    UpdateData(false);
  } else
  {
    m_mess = SPROX_GetErrorMessage(rc);
  }
  UpdateData(false);
}
#endif

void CSproxTestDlg::UpdateFormState(BOOL working)
{
  /* Hide or show Open/Close and Pause/Resume buttons */
  m_open.ShowWindow(!reader_open);
  m_close.ShowWindow(reader_open);
  m_pause.ShowWindow(reader_active);
  m_resume.ShowWindow(!reader_active);

  /* Enable or disable Open/Close and Pause/Resume buttons */
  m_open.EnableWindow(!working);
  m_close.EnableWindow(!working);
  m_pause.EnableWindow((!working) && reader_open);
  m_resume.EnableWindow((!working) && reader_open);

  /* Various buttons */
  m_load_keys.EnableWindow((!working) && reader_open && reader_active);

  /* Tag control buttons */
  m_select_any.EnableWindow((!working) && reader_open && reader_active);
  m_select_idle.EnableWindow((!working) && reader_open && reader_active);
  m_select_wakeup.EnableWindow((!working) && reader_open && reader_active
                               && tag_found);
  m_halt.EnableWindow((!working) && reader_open && reader_active
                      && tag_found);

  /* Tag edit buttons */
  m_address_inc.EnableWindow((!working) && reader_open && reader_active
                             && tag_found);
  m_address_dec.EnableWindow((!working) && reader_open && reader_active
                             && tag_found);
  m_address_mode.EnableWindow((!working) && reader_open && reader_active
                              && tag_found);
  m_read.EnableWindow((!working) && reader_open && reader_active
                      && tag_found);

  UpdateData(false);
}

/*
 * Display activated tag information
 * ---------------------------------
 * NOTE : the Read/Write functions work only with Mifare Classic (1k / 4k) or
 *        Mifare UltraLite tags.
 */
void CSproxTestDlg::UpdateTag()
{
  if (tag_found)
  {
    BYTE snrlen = 4;
    int i;
    TCHAR tmp[3];
    TCHAR buffer[64] = _T("");

    if ((tag_atq[0] & 0xC0) == 0x40)
      snrlen = 7;
    if ((tag_atq[0] & 0xC0) == 0x80)
      snrlen = 10;

    if (snrlen == 4)
    {
      for (i = 0; i < 4; i++)
      {
        swprintf(tmp, _T("%02X"), tag_snr[3 - i]);
        wcscat(buffer, tmp);
      }
    } else
    {
      for (i = 0; i < snrlen; i++)
      {
        swprintf(tmp, _T("%02X"), tag_snr[i]);
        wcscat(buffer, tmp);
      }
    }

    m_tag_snr = buffer;

    swprintf(buffer, _T("%02X%02X"), tag_atq[1], tag_atq[0]);
    m_tag_atq = buffer;

    swprintf(buffer, _T("%02X"), tag_sak[0]);
    m_tag_sak = buffer;

    tag_type = 3;
    if (tag_sak[0] & 0x20)
    {
      tag_type = 4;
    } else if (tag_atq[1] == 0x00)
    {
      if (tag_atq[0] == 0x44)
      {
        tag_type = 0;
      } else if (tag_atq[0] == 0x02)
      {
        tag_type = 1;
      } else if (tag_atq[0] == 0x04)
      {
        tag_type = 2;
      }
    }
    switch (tag_type)
    {
      case 4:
        m_action = "ISO 14443-A T=CL tag activated";
        break;
      case 3:
        m_action = "Unsupported ISO 14443-A layer 3 tag";
        break;
      case 2:
        m_action = "Mifare 1k tag activated";
        break;
      case 1:
        m_action = "Mifare 4k tag activated";
        break;
      case 0:
        m_action = "Mifare UltraLite tag activated";
        tag_addr_sect = false;
        break;
    }
  } else
  {
    m_tag_snr = "";
    m_tag_atq = "";
    m_tag_sak = "";
  }

  UpdateAddress(0);
  UpdateData(false);
}

void CSproxTestDlg::UpdateAddress(int what)
{
  TCHAR buffer[64] = _T("");

  /* Change address value */
  if (what < 0)
  {
    if (tag_addr == 0)
    {
      if (tag_addr_sect)
      {
        /* We use sectors */
        switch (tag_type)
        {
          case 2:              /* Mifare 1k */
            tag_addr = 15;
            break;
          case 1:              /* Mifare 4k */
            tag_addr = 39;
            break;
        }
      } else
      {
        /* We use direct addressing */
        switch (tag_type)
        {
          case 2:              /* Mifare 1k */
            tag_addr = 63;
            break;
          case 1:              /* Mifare 4k */
            tag_addr = 255;
            break;
          case 0:              /* Mifare UL */
            tag_addr = 15;
            break;
        }
      }
    } else
      tag_addr--;
  } else if (what > 0)
  {
    if (tag_addr_sect)
    {
      /* We use sectors */
      switch (tag_type)
      {
        case 2:                /* Mifare 1k */
          if (tag_addr >= 15)
          {
            tag_addr = 0;
            what = 0;
          }
          break;
        case 1:                /* Mifare 4k */
          if (tag_addr >= 39)
          {
            tag_addr = 0;
            what = 0;
          }
          break;
      }
    } else
    {
      /* We use direct addressing */
      switch (tag_type)
      {
        case 2:                /* Mifare 1k */
          if (tag_addr >= 63)
          {
            tag_addr = 0;
            what = 0;
          }
          break;
        case 1:                /* Mifare 4k */
          if (tag_addr >= 255)
          {
            tag_addr = 0;
            what = 0;
          }
          break;
        case 0:                /* Mifare UL */
          if (tag_addr >= 15)
          {
            tag_addr = 0;
            what = 0;
          }
          break;
      }
    }
    if (what > 0)
      tag_addr++;
  }

  /* Display current address */
  if (tag_addr_sect)
  {
    switch (tag_type)
    {
      case 2:                  /* Mifare 1k */
        swprintf(buffer, _T("Sector %d/%d"), tag_addr, 15);
        break;
      case 1:                  /* Mifare 4k */
        swprintf(buffer, _T("Sector %d/%d"), tag_addr, 39);
        break;
    }
  } else
  {
    switch (tag_type)
    {
      case 2:                  /* Mifare 1k */
        swprintf(buffer, _T("Block %d/%d"), tag_addr, 63);
        break;
      case 1:                  /* Mifare 4k */
        swprintf(buffer, _T("Block %d/%d"), tag_addr, 255);
        break;
      case 0:                  /* Mifare UL */
        swprintf(buffer, _T("Page %d/%d"), tag_addr, 15);
        break;
    }
  }

  m_address = buffer;
  UpdateData(false);
}

/*
 * OPEN button
 * -----------
 * We retrieve library's version and try to connect to the SpringProx device.
 * If the device is found we display its information :
 * - version,
 * - RC chipset ID
 * - RC chipset serial number
 */
void CSproxTestDlg::OnOpen()
{
  SWORD rc;
  SWORD err = 0;
  TCHAR buffer[200];
  BYTE dev_type[5], dev_snr[4];

  CWaitCursor patient;

  m_action = "Opening reader...";
  m_result = "";

  UpdateFormState(true);

  /* Get library version */
  m_result = "GetLibrary";
  UpdateData(false);
  rc = SPROX_GetLibrary(buffer, sizeof(buffer) / sizeof(TCHAR));
  if (rc != MI_OK)
  {
    m_library = "fatal error";
    m_result = CString(SPROX_GetErrorMessage(rc));
    UpdateFormState(false);
    return;
  }
  m_library = buffer;

  /* Connect to the device */
  m_result = "ReaderOpen";
  UpdateData(false);
  rc = SPROX_ReaderOpen(NULL);
  if (rc != MI_OK)
  {
    m_firmware = "reader not found";
    m_result = CString(SPROX_GetErrorMessage(rc));
    UpdateFormState(false);
    return;
  }

  reader_open = true;
  reader_active = true;

  /* Retrieve the serial device name */
  m_result = "ReaderGetDevice";
  UpdateData(false);
  rc = SPROX_ReaderGetDevice(buffer, sizeof(buffer) / sizeof(TCHAR));
  if (rc == MI_OK)
    m_comm = buffer;
  else
    m_comm = "?";
  UpdateData(false);

  /* Retrieve device's firmware */
  m_result = "ReaderGetFirmware";
  UpdateData(false);
  rc = SPROX_ReaderGetFirmware(buffer, sizeof(buffer) / sizeof(TCHAR));
  if (rc != MI_OK)
  {
    m_firmware = "reader error";
    m_result = CString(SPROX_GetErrorMessage(rc));
    UpdateData(false);
  } else
  {
    /* Firmware is : */
    m_firmware = buffer;
  }

  /* Device identifier */
  m_result = "ReaderGetRc500Id";
  UpdateData(false);
  rc = SPROX_ReaderGetRc500Id(dev_type, dev_snr);
  if (rc != MI_OK)
  {
    m_devtype = "err.";
    m_devsnr = "err.";
    m_result = CString(SPROX_GetErrorMessage(rc));
    UpdateData(false);
  } else
  {
    /* Device is : */
    swprintf(buffer, _T("%02X%02X%02X%02X%02X"), dev_type[0], dev_type[1],
             dev_type[2], dev_type[3], dev_type[4], dev_type[5]);
    m_devtype = buffer;
    swprintf(buffer, _T("%02X%02X%02X%02X"), dev_snr[0], dev_snr[1],
             dev_snr[2], dev_snr[3]);
    m_devsnr = buffer;
  }

  m_action = "Ready";
  m_result = "";
  patient.Restore();
  UpdateFormState(false);
}

/*
 * CLOSE button
 * ------------
 * We disconnect from the SpringProx device
 */
void CSproxTestDlg::OnClose()
{
  m_action = "Closing reader...";
  m_result = "";
  UpdateFormState(true);
  SPROX_ReaderClose();
  reader_open = false;
  reader_active = false;
  m_action = "Reader closed";
  UpdateFormState(false);
}


void CSproxTestDlg::OnPause()
{
  m_action = "Pausing reader...";
  m_result = "";
  UpdateFormState(true);
  SPROX_ReaderDeactivate();
  reader_active = false;
  m_action = "Reader paused";
  UpdateFormState(false);
}

void CSproxTestDlg::OnResume()
{
  SWORD rc;

  m_action = "Waking reader up...";
  m_result = "";
  UpdateFormState(true);

  m_result = "ReaderActivate";
  UpdateData(false);
  rc = SPROX_ReaderActivate();
  if (rc != MI_OK)
  {
    m_result = CString(SPROX_GetErrorMessage(rc));
    UpdateData(false);
    return;
  } else
  {
    reader_active = true;
    m_action = "Ready";
    m_result = "";
    UpdateFormState(false);
    return;
  }

  /* Failed to wake-up the reader, let's perform the whole OPEN sequence */
  SPROX_ReaderClose();
  reader_open = false;
  OnOpen();
}

/*
 * Load default Mifare keys to MfRC5xx E2PROM
 * ------------------------------------------
 * We load a few "well-known" keys in CRYPTO1 non-volatile secured memory.
 * This is done once in factory and doesn't need to be done later (unless
 * you want to revert your reader to factory settings).
 */
#define PICC_AUTHENT1A 0
#define PICC_AUTHENT1B 1
void CSproxTestDlg::OnLoadKeys()
{
  static const BYTE key_Ax[6] = { 0xA0, 0xA1, 0xA2, 0xA3, 0xA4, 0xA5 };
  static const BYTE key_Bx[6] = { 0xB0, 0xB1, 0xB2, 0xB3, 0xB4, 0xB5 };

  BYTE buffer[6];
  SWORD rc;

  m_action = "Loading default Mifare keys to E2PROM...";
  m_result = "";
  UpdateFormState(true);


  /* Base key A */
  rc = Mf500PcdLoadKeyE2(PICC_AUTHENT1A, 0, (BYTE *) key_Ax);

  /* Base key B */
  if (rc == MI_OK)
    rc = Mf500PcdLoadKeyE2(PICC_AUTHENT1B, 0, (BYTE *) key_Bx);

  /* Transport key FF */
  memset(buffer, 0xFF, 6);
  if (rc == MI_OK)
    rc = Mf500PcdLoadKeyE2(PICC_AUTHENT1A, 1, buffer);
  if (rc == MI_OK)
    rc = Mf500PcdLoadKeyE2(PICC_AUTHENT1B, 1, buffer);

  /* Transport key (?) 00 */
  memset(buffer, 0x00, 6);
  if (rc == MI_OK)
    rc = Mf500PcdLoadKeyE2(PICC_AUTHENT1A, 2, buffer);
  if (rc == MI_OK)
    rc = Mf500PcdLoadKeyE2(PICC_AUTHENT1B, 2, buffer);

  /* DEMO_x */
  memcpy(buffer, "DEMO_", 5);
  buffer[5] = 'A';

  if (rc == MI_OK)
    rc = Mf500PcdLoadKeyE2(PICC_AUTHENT1A, 3, buffer);

  buffer[5] = 'B';
  if (rc == MI_OK)
    rc = Mf500PcdLoadKeyE2(PICC_AUTHENT1B, 3, buffer);

  /* TEST_x */
  memcpy(buffer, "TEST_", 5);
  buffer[5] = 'A';

  if (rc == MI_OK)
    rc = Mf500PcdLoadKeyE2(PICC_AUTHENT1A, 4, buffer);

  buffer[5] = 'B';
  if (rc == MI_OK)
    rc = Mf500PcdLoadKeyE2(PICC_AUTHENT1B, 4, buffer);

  if (rc != MI_OK)
  {
    m_action = "Failed to load the keys";
    m_result = CString(SPROX_GetErrorMessage(rc));
  } else
  {
    m_action = "";
  }
  UpdateFormState(false);
}

/*
 * Activation of any ISO 14443-A tag (either IDLE or HALTED)
 * ---------------------------------------------------------
 * The reader performs internally the whole anti-collision /
 * selection / activation loop.
 */
void CSproxTestDlg::OnSelectAny()
{
  SWORD rc;

  m_action = "ISO 14443-A activate any...";
  m_result = "";
  tag_found = false;
  tag_addr = 0;
  m_address = "";
  m_value = "";
  UpdateFormState(true);

  rc = SPROX_MifStSelectAny(tag_snr, tag_atq, tag_sak);
  if (rc != MI_OK)
  {
    m_action = "No ISO 14443-A tag found";
    m_result = CString(SPROX_GetErrorMessage(rc));
  } else
  {
    tag_found = true;
  }

  UpdateTag();
  UpdateFormState(false);
}

/*
 * Activation of an IDLE ISO 14443-A tag (HALTED tags won't answer)
 * ----------------------------------------------------------------
 * The reader performs internally the whole anti-collision /
 * selection / activation loop.
 */
void CSproxTestDlg::OnSelectIdle()
{
  SWORD rc;

  m_action = "ISO 14443-A activate idle...";
  m_result = "";
  tag_found = false;
  tag_addr = 0;
  m_address = "";
  m_value = "";
  UpdateFormState(true);

  rc = SPROX_MifStSelectIdle(tag_snr, tag_atq, tag_sak);
  if (rc != MI_OK)
  {
    m_action = "No ISO 14443-A tag found";
    m_result = CString(SPROX_GetErrorMessage(rc));
  } else
  {
    tag_found = true;
  }

  UpdateTag();
  UpdateFormState(false);
}

/*
 * Wakeup a previously HALTED tag (knowing its SNR)
 * ------------------------------------------------
 * The reader performs internally the whole anti-collision /
 * selection / activation loop.
 */
void CSproxTestDlg::OnSelectWakeup()
{
  SWORD rc;

  m_action = "Waking up previous tag...";
  m_result = "";
  UpdateFormState(true);

  rc = SPROX_MifStSelectAgain(tag_snr);
  if (rc != MI_OK)
  {
    tag_found = false;
    m_action = "Wake-up failed, tag lost";
    m_result = CString(SPROX_GetErrorMessage(rc));
  }

  UpdateTag();
  UpdateFormState(false);
}

/*
 * Put current tag in ISO 14443-A HALTED state
 * -------------------------------------------
 */
void CSproxTestDlg::OnHalt()
{
  m_action = "Halting the tag...";
  m_result = "";
  UpdateFormState(true);
  SPROX_MifStHalt();
  m_action = "";
  UpdateFormState(false);
}

/*
 * Change software adressing mode (toggle between block or page, and sector)
 * -------------------------------------------------------------------------
 */
void CSproxTestDlg::OnAddressMode()
{
  switch (tag_type)
  {
    case 2:
    case 1:
      tag_addr_sect = !tag_addr_sect;
      tag_addr = 0;
      UpdateAddress(0);
      break;
  }
}

/*
 * Increment / decrement current address
 * -------------------------------------
 */
void CSproxTestDlg::OnAddressDec()
{
  UpdateAddress(-1);
}

void CSproxTestDlg::OnAddressInc()
{
  UpdateAddress(1);
}

/*
 * Read selected tag at current address
 * ------------------------------------
 */
void CSproxTestDlg::OnRead()
{
  SWORD rc;
  BYTE value[240];
  TCHAR buffer[512], tmp[3];
  int i, length = 0;

  m_value = "";

  if (tag_addr_sect)
  {
    switch (tag_type)
    {
      case 2:                  /* Mifare 1k */
        swprintf(buffer, _T("Sector %d/%d on display"), tag_addr, 15);
        length = 48;
        break;
      case 1:                  /* Mifare 4k */
        swprintf(buffer, _T("Sector %d/%d on display"), tag_addr, 39);
        if (tag_addr < 20)
          length = 48;
        else
          length = 240;
        break;
    }
  } else
  {
    switch (tag_type)
    {
      case 2:                  /* Mifare 1k */
        swprintf(buffer, _T("Block %d/%d on display"), tag_addr, 63);
        length = 16;
        break;
      case 1:                  /* Mifare 4k */
        swprintf(buffer, _T("Block %d/%d on display"), tag_addr, 255);
        length = 16;
        break;
      case 0:                  /* Mifare UL */
        swprintf(buffer, _T("Page %d/%d on display"), tag_addr, 15);
        length = 4;
        break;
    }
  }

  if (length == 0)
    return;

  m_action = "Reading...";
  m_result = "";
  UpdateFormState(true);

  if (tag_addr_sect)
  {
    switch (tag_type)
    {
      case 2:
      case 1:
        rc = SPROX_MifStReadSector(NULL, tag_addr, value, NULL);
        break;
      default:
        return;
    }
  } else
  {
    switch (tag_type)
    {
      case 2:
      case 1:
        rc = SPROX_MifStReadBlock(NULL, tag_addr, value, NULL);
        break;
      case 0:
        rc = Mf500PiccRead(tag_addr, value);
        break;
      default:
        return;
    }
  }

  if (rc != MI_OK)
  {
    m_result = CString(SPROX_GetErrorMessage(rc));
  } else
  {
    m_action = buffer;

    buffer[0] = '\0';
    for (i = 0; i < length; i++)
    {
      swprintf(tmp, _T("%02X"), value[i]);
      wcscat(buffer, tmp);
      if (i % 16 == 15)
        wcscat(buffer, _T("\r\n"));
    }

    m_value = buffer;
  }

  UpdateFormState(false);
}
